Doomsday Engine - Bug #637

[Hexen] Class change in-game causes instability, issues
2009-03-02 22:04 - jimigrey

Status: New Start date: 2009-03-02
Priority: High % Done: 0%
Assignee:

Category: Defect

Target version: Modding

Description

| thought it would be cool to change the character class in the middle of the game by using bindings, so | don't have to type stuff
everytime | want to change.

There are some bugs:

The player view angles changes. This is not so life threatening as the next one..

The monsters may ignore the visible player and start attacking some invisible thing in the spot | had changed my class. This will give
damage and | will notice it when | change back to the class | was at that spot. They can also kill player by killing the invisible one. |
think the current player became immobilized + view lowered when they killed the invisible one. Then the monsters came to me and

attacked me until | had my health down to 0.

I'm not exactly sure what causes them sometimes attack some invisible thing, but it seems to happen more often when the monsters
can't get to me or when they don't see me. Sometimes as much as | try to cause the bug, the monsters just keep targeting me.

It happens with both shadowcaster cheat and using class in the console. I've tried it in 1.8.6 and 1.9.0-beta6 and happend in both.
| attached my key bindings as a text file..

Labels: Hexen

History

#1 - 2009-03-02 22:04 - jimigrey

Class changing weapon bindings

Attachments:

e http://sourceforge.net/p/deng/bugs/ discuss/thread/83384292/a95e/attachment/hexen_class_weapon_change_binds.txt

#2 - 2009-03-12 09:08 - danij

When a player class change occurs, the player is spawned again at the same location resulting in a new mobj. Problem is, there could be pointers to
the old mobj all over the place, for sector sound origins and indeed enemy pursuit targets. Even though the old mobj is "removed", it may not actually
be free'd, instead being moved to list of used mobjs ready for reuse, however, it might be a while before that happens and in the mean time, pointers
to it are still valid. Thats why attacking the empty spot where you were when you changed class still causes you damage because there is copy of
yourself there.

Why are we calling P_SpawnPlayer in this instance? Do we truely want a new mobj at this time? If so then obviously we have quite a bit of
bookkeeping that is missing that needs adding.

Or by calling P_SpawnPlayer are we just trying to return the player to the state they would be in had they spawned at the current player position and
of the target class? If so then it would be a good idea to split the default player state setup out of P_SpawnPlayer and into a new routine which can be
called by both P_SpawnPlayer and P_PlayerChangeClass.

Personally, | favour doing the later as its simpler all round.

#3 - 2009-03-20 13:07 - danij

After further investigation, doing this the proposed "easy" way would not actually be possible without first addressing a fundamental design issue:

In Hexen, each player class has mobj type specifically for that class (fighter = MT_PLAYER_FIGHTER, cleric = MT_PLAYER_CLERIC, etc...).

So that means that we need either need to change the mobj type dynamically (might be tricky? what is tied to this?) or we need to revise how we
interpret the mobj types for jHexen, spawning all players as MT_PLAYER and then picking the Mobj type definition according to a mobj_t->type AND
mobj_t->class.

#4 - 2012-08-25 22:50 - danij

I'm raising the priority of this to a more appropriate level because it is a real stability issue. Particularly in multiplayer where there is the very real
possibility of crashing the server merely by playing the game in the intended manner. See my comment on 2009-03-12 at 02:08 PDT for more details.
#5 - 2012-08-26 15:51 - skyjake

Note that since commit d407b76c, Hexen's player class changes only occur when players respawn.

#6 - 2012-08-26 15:59 - danij

In deathmatch yes, however when the player morphs to a pig in coop the same dangling pointers are left behind as in singleplayer.

#7 - 2012-08-27 20:17 - danij

- labels: jHexen Gameplay --> Hexen

#8 - 2013-10-22 18:43 - skyjake

- Tags set to Gameplay, Hexen

- Subject changed from [Hexen] Class change in-game => playsim update issues to [Hexen] Class change in-game causes instability, issues
- Category set to Defect

- Priority changed from Normal to High

- Target version deleted (1.8.6)

#9 - 2017-04-03 14:57 - skyjake

- Target version set to Modding
